# coding: utf-8

"""
    OQTOPUS Cloud User API

    OQTOPUS Cloud User API. This API is used to interact with the OQTOPUS Cloud service. The API provides endpoints to manage devices, jobs, and results.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: oqtopus-team[at]googlegroups.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class JobsSubmitJobInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'program': 'list[str]',
        'operator': 'list[JobsOperatorItem]'
    }

    attribute_map = {
        'program': 'program',
        'operator': 'operator'
    }

    def __init__(self, program=None, operator=None):  # noqa: E501
        """JobsSubmitJobInfo - a model defined in Swagger"""  # noqa: E501
        self._program = None
        self._operator = None
        self.discriminator = None
        self.program = program
        if operator is not None:
            self.operator = operator

    @property
    def program(self):
        """Gets the program of this JobsSubmitJobInfo.  # noqa: E501

        A list of OPENQASM3 program. For non-multiprogramming jobs, this field is assumed to contain exactly one program. Otherwise, those programs are combined according to the multiprogramming machinery.  # noqa: E501

        :return: The program of this JobsSubmitJobInfo.  # noqa: E501
        :rtype: list[str]
        """
        return self._program

    @program.setter
    def program(self, program):
        """Sets the program of this JobsSubmitJobInfo.

        A list of OPENQASM3 program. For non-multiprogramming jobs, this field is assumed to contain exactly one program. Otherwise, those programs are combined according to the multiprogramming machinery.  # noqa: E501

        :param program: The program of this JobsSubmitJobInfo.  # noqa: E501
        :type: list[str]
        """
        if program is None:
            raise ValueError("Invalid value for `program`, must not be `None`")  # noqa: E501

        self._program = program

    @property
    def operator(self):
        """Gets the operator of this JobsSubmitJobInfo.  # noqa: E501


        :return: The operator of this JobsSubmitJobInfo.  # noqa: E501
        :rtype: list[JobsOperatorItem]
        """
        return self._operator

    @operator.setter
    def operator(self, operator):
        """Sets the operator of this JobsSubmitJobInfo.


        :param operator: The operator of this JobsSubmitJobInfo.  # noqa: E501
        :type: list[JobsOperatorItem]
        """

        self._operator = operator

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(JobsSubmitJobInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, JobsSubmitJobInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
